Pro locate_clusters,im,n,x,y,nx,ny,filter,MASK=mask,NOISE=noise,SCALED_OFFSET=scaled_offset $
                   ,SMOOTH=smooth_filter

  imm=bytarr(nx,ny)
  if keyword_set(scaled_offset) then begin
    offset=keyword_set(noise)?noise*(1.+total(im,1)/nx/mean(im)):1.05
    if(n_elements(mask) eq n_elements(im)) then begin
      if(keyword_set(smooth_filter)) then begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*]*mask[ix,*])-offset $
                     -smooth(reform(float(im[ix,*]*mask[ix,*])),filter)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endif else begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*]*mask[ix,*])-offset $
                     -opt_filter(reform(float(im[ix,*])),weight=reform(mask[ix,*]),filter>1.d0)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endelse
    endif else begin
      if(keyword_set(smooth_filter)) then begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*])-offset-smooth(reform(float(im[ix,*])),filter)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endif else begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*])-offset-opt_filter(reform(float(im[ix,*])),filter>1.d0)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endelse
    endelse
  endif else begin
    if(n_elements(mask) eq n_elements(im)) then begin
      if(keyword_set(smooth_filter)) then begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*]*mask[ix,*])-noise $
                     -smooth(reform(float(im[ix,*]*mask[ix,*])),filter)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endif else begin
        for ix=0,nx-1 do begin
          mm=float(im[ix,*]*mask[ix,*])-noise $
                     -opt_filter(reform(float(im[ix,*])),weight=reform(mask[ix,*]),filter>1.d0)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endelse
    endif else begin
      if(keyword_set(smooth_filter)) then begin
        for ix=0,nx-1 do begin
          mm=float(reform(im[ix,*]))
          mm=mm-noise-exp(smooth(alog(mm>1.),filter>1))
;          mm=float(im[ix,*])-noise-smooth(reform(float(im[ix,*])),filter)
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endif else begin
        for ix=0,nx-1 do begin
;          mm=float(im[ix,*])-noise-opt_filter(reform(float(im[ix,*])),filter>1.d0)
          mm=float(reform(im[ix,*]))
          mm=mm-noise-exp(opt_filter(alog(mm>1.),filter>1.d0))
          i=where(mm gt 0., ni)
          if(ni gt 0) then imm[ix,i]=1B
;          if(ix eq nx/2) then stop
        endfor
      endelse
    endelse
  endelse
;  imm[*,*]=0B
;  if(keyword_set(mask)) then begin
;    imm[where(im*mask gt smooth(im, filter)*offset)]=1B
;  endif else begin
;    imm[where(im gt smooth(im, filter)*offset)]=1B
;  endelse
  y=where(imm eq 1B, ni)
  if(ni le 0) then begin
    print,'MARK_ORDERS: This should never happen'
    stop
  endif

;  imm=float(im)
;  for ix=0,nx-1 do imm[ix,*]=float(im[ix,*])-opt_filter(float(im[ix,*]),filter)
;  mm=minmax(imm)
;  nn=0.001*n
;  bin=(mm(1)-mm(0))/nn
;  h=histogram(imm,bin=bin)
;  m=max(h,imax)
;  h=[h[0:imax],h[imax-1-indgen(imax)]]
;  xx=(dindgen(2*imax+1)-imax)*bin
;  z=gaussfit(xx,h,ag,nterms=3)
;  h=ag(2)
;  y=where(imm gt 2.d0*h)

  x=y mod nx
  y=y/nx
;display,float(imm)
;stop
  return
end

Pro mark_orders, im,orders, POWER=power, FILTER=filter $
               , ERROR=ord_err, THRES=thres, PLOT=iplot $
               , POLARIM=polarim, MASK=mask, MANUAL=MANUAL $
               , NOISE=noise, COLOR=color, SCALED_OFFSET=scaled_offset $
               , CLUSTER_LIMITS=cl_limits, SMOOTH=smooth_filter

  common reduce_library,library_name

  if(n_params() lt 2) then begin
    print,'Syntax: mark_orders,im,orders[,POWER=power[,FILTER=filter $'
    print,'                  [,THRES=thres[,/PLOT[,/POLARIM[,MASK=mask $'
    print,'                  [,/MANUAL[,NOISE=noise[,SHIFT_OFFSET=shift_off]]]]]]]]]'
    print,'        im      - 2D array [nx,ny] with spectral orders oriented horizontally'
    print,'        orders  - 2D array [power,norders] with polynomial approximation to order shape'
    print,'        power   - power of the polynomial fit. Default is 2 (parabola).'
    print,'        filter  - parameter of the optimal filter used to detect high pixels. Default: 40.'
    print,'        ord_err - [norders] error of the polynomial fit to spectral orders'
    print,'        thres   - minimum group of pixels to be considered is part of spectral order. Default:400'
    print,'        /PLOT   - if set, execute mark_orders in interactive mode'
    print,'        /POLARIM- if set, assumes pairs of orders prodeced by beamsplitter'
    print,'        mask    - 2D byte array [nx,ny] marks good (1B) and bad (0B) pixels'
    print,'        /MANUAL - all cluster merging is done in interactive mode'
    print,'        noise   - readout noise of the CCD may be important if the S/N'
    print,'                  in the image used is too low'
    print,'        cl_limits - optional parameter containing starting/ending columns of each cluster'
    print,'        scaled_off- the threshold is a fixed amount defined by noise rather then a scaling'
    print,'                    of the local smoothed value determined as 2*noise/mean(im)' 
    print,'       /COLOR  - use colors when marking clusters.' 
   return
  endif

  sz=size(im)
  nx=sz(1)
  ny=sz(2)
  n=n_elements(im)

;Set then noise of not set
  if n_elements(noise) eq 0 then noise=1.

;Get X and Y coordinates of all pixels sticking above the filtered image
  if(not keyword_set(filter)) then filter=20.d0
  locate_clusters,im,n,x,y,nx,ny,filter,MASK=mask,NOISE=noise $
                 ,SCALED_OFFSET=scaled_offset,SMOOTH=smooth_filter

;Locate and mark clusters of pixels
  if(keyword_set(iplot)) then begin
    if(keyword_set(color)) then colors else loadct,0,/SILENT
  endif
  if(not keyword_set(thres)) then thres=400

  if(not keyword_set(library_name)) then begin
    help,calls=a
    delimiter=path_sep()
    i1=strpos(a[0],'<')+1
    prefix=file_dirname(strmid(a[0],i1))
    name=prefix+delimiter+'reduce.so.'   $
                         +!version.os+'.' $
                         +!version.arch+'.' $
                         +strtrim(!version.MEMORY_BITS,2)
    if (file_info(name)).EXISTS then library_name=name
  endif

  if keyword_set(library_name) then begin
    nn=n_elements(x)
    index=lonarr(nn)
;time1=systime(1)
    nregions=CALL_EXTERNAL(library_name, 'cluster'                       $
                          ,long(x), long(y), nn, long(nx), long(ny) $
                          ,long(thres), index)
    if(nregions lt 0) then stop
    nregions=nregions+1
  endif else begin
;time2=systime(1)
    index=cluster(x,y,nx,ny,nregions=nregions,thres=thres,PLOT=iplot)
;time3=systime(1)
  endelse

  ind=where(index gt 0)
  if(n gt thres) then begin
    x=x(ind)
    y=y(ind)
    index=index(ind)
  endif else begin
    print,'MARK_ORDERS: No clusters identified'
    stop
  endelse

  if nregions le 1 then begin
    print,'MARK_ORDERS: No clusters identified'
    stop
  endif

;Find all the clusters crossing the bottom boundary and reject pixels in columns touching the boundary
  icross=where(y eq 0, ncross)
  if(ncross gt 0) then begin         ;Found some pixels
    icross=index(icross)             ;Get cluster numbers
    icross=icross(sort(icross))      ;Sort for unique to work
    icross=icross(uniq(icross))      ;Keep different cluster numbers only
    ncross=n_elements(icross)        ;Number of suspicious clusters
    for i=0,ncross-1 do begin        ;Loop through clusters
      if(icross(i) gt 0) then begin
        ind=where(icross(i) eq index)  ;Find all the pixels in the border cluster
        bind=ind(where(y[ind] eq 0,nbind));All the border pixels in this cluster
        for ii=0L,nbind-1 do begin
          j=ind[where(x[ind] eq x[bind[ii]])]
          index[j]=0
        endfor
;        xbmin=min(x[bind])             ;Smallest X
;        xbmax=max(x[bind])             ;Largest X
;        xbmean=0.5*(xbmin+xbmax)       ;Mean X for border pixels
;        xmean=mean(x[ind])             ;Mean X for all pixels in this cluster
;        if(xmean lt xbmean) then begin ;Most of the cluster is located to the left of xbmean
;          j=ind[where(x[ind] ge xbmin)];Find the ones that can be influenced by the edge
;          index[j]=0                   ;Whipe them out
;        endif else begin               ;Most of the cluster is located to the right of xbmean
;          j=ind[where(x[ind] le xbmax)];Find the ones that can be influenced by the edge
;          index[j]=0                   ;Whipe them out
;        endelse
      endif
    endfor
  endif

;Find all the clusters crossing the top boundary and reject pixels in columns touching the boundary
  icross=where(y eq ny-1, ncross)
  if(ncross gt 0) then begin         ;Found some pixels
    icross=index[icross]             ;Get cluster numbers
    icross=icross[sort(icross)]      ;Sort for unique to work
    icross=icross[uniq(icross)]      ;Keep different cluster numbers only
    ncross=n_elements(icross)        ;Number of suspicious clusters
    for i=0,ncross-1 do begin        ;Loop through clusters
      if(icross[i] gt 0) then begin
        ind=where(icross[i] eq index)  ;Find all the pixels in the border cluster
        bind=ind(where(y[ind] eq ny-1,nbind));All the border pixels in this cluster
        for ii=0L,nbind-1 do begin
          j=ind[where(x[ind] eq x[bind[ii]])]
          index[j]=0
        endfor
;        xbmin=min(x[bind])             ;Smallest X
;        xbmax=max(x[bind])             ;Largest X
;        xbmean=0.5*(xbmin+xbmax)       ;Mean X for border pixels
;        xmean=mean(x[ind])             ;Mean X for all pixels in this cluster
;        if(xmean lt xbmean) then begin ;Most of the cluster is located to the left of xbmean
;          j=ind[where(x[ind] ge xbmin)];Find the ones that can be influenced by the edge
;          index[j]=0                   ;Whipe them out
;        endif else begin               ;Most of the cluster is located to the right of xbmean
;          j=ind[where(x[ind] le xbmax)];Find the ones that can be influenced by the edge
;          index[j]=0                   ;Whipe them out
;        endelse
      endif
    endfor
  endif

;Repeat size-based cluster rejection in case some clusters became too small
  jreg=0
  for ireg=1,nregions-1 do begin
    j=where(index eq ireg, nj)
    if(nj gt 0) then begin
      if(nj lt thres and nj gt 0) then begin
       index[j]=0
      endif else begin
       jreg=jreg+1
       index[j]=jreg
      endelse
    endif
  endfor

;Get the number of clusters and their indices
  nregions=jreg+1

;  mean_cluster_thickness=0.
;  for ireg=1,nregions-1 do begin
;    j=where(index eq ireg, nj)
;    if(nj eq 0) then stop
;    xx=x[j]
;    yy=y[j]
;    j=sort(xx)
;    xx=xx[j]
;    yy=yy[j]
;    j=uniq(xx)
;    delta_y_cluster=0.
;    for jj=0,n_elements(j)-1 do begin
;      dy=minmax(yy[where(xx eq xx[j[jj]])]) 
;      delta_y_cluster=delta_y_cluster+dy[1]-dy[0]
;    endfor
;    deta_y_cluster=delta_y_cluster/n_elements(j)
;    mean_cluster_thickness=mean_cluster_thickness+deta_y_cluster
;  endfor
;  mean_cluster_thickness=1.5*mean_cluster_thickness/(nregions-1)

  xx=dindgen(nx)
  if(not keyword_set(power)) then power=2

  skip=[0,0]
  silent=0

  loadct,0,/SILENT
  if(keyword_set(iplot)) then begin
    window,1
    wset,0
  endif

next:
  if(keyword_set(iplot)) then if(silent ne 1) then display,im,/log
;  if(keyword_set(iplot)) then begin
;    display,im,/log,yr=[3000,3143]
;    j=where(index gt 0)
;    oplot,x[j],y[j],psym=3,col=0
;stop
;  endif
  yy=fltarr(nx,nregions-1)
  yy_top=intarr(nx,nregions-1)
  yy_bot=intarr(nx,nregions-1)
  yycos=fltarr(nx,nregions-1)
  ord_err=dblarr(nregions-1)
  orders=dblarr(power+1,nregions-1)
  xoffset=dblarr(nregions-1)
  xscale=dblarr(nregions-1)
  ind=0
  cl_limits=intarr(2,nregions-1)   ; starting and ending columns of clusters
  for ireg=1,nregions-1 do begin
    j=where(index eq ireg, nj)
    if(nj gt 0) then begin ; Check if cluster is not empty
      pwr=power<(n_elements(uniq(x[j],sort(x[j])))-1); restrict the power if not enough x's
      if(pwr gt 0) then begin                        ; Check if cluster includes
        index[j]=ind+1                               ; enough different pixels
        xoffset[ind]=double(mean(x[j]))              ; Offset argument in poly_fit
        xscale[ind]=1.d0/max(abs(x[j]-xoffset[ind]))
        coef=poly_fit((x[j]-xoffset[ind])*xscale[ind],y[j],pwr,/double)
                                                     ; Check if this cluster is
                                                     ; not a vertical artifact
        if(abs((poly_fit((x[j]-xoffset[ind]),y[j],1,/double))(1)) lt $
                               4.*ny/nx) then begin
          cl_limits[*,ind]=minmax(x[j])
          orders[0:pwr,ind]=reform(coef)
          yy[*,ind]=poly((xx-xoffset[ind])*xscale[ind],orders[*,ind])
;          yy_top[*,ind]=yy[*,ind]
;          yy_bot[*,ind]=yy[*,ind]
;          for xclust=cl_limits[0,ind],cl_limits[1,ind] do begin
;            kkk=where(x[j] eq xclust, nclust)
;            if nclust gt 0 then begin
;              yy_top[xclust,ind]=max(y[j[kkk]])
;              yy_bot[xclust,ind]=min(y[j[kkk]])
;            endif
;          endfor

          yycos[*,ind]=poly((xx-xoffset[ind])*xscale[ind],orders[1:*,ind]*(dindgen(pwr)+1))
          yycos[*,ind]=yycos[*,ind]*xscale[ind]
          yycos[*,ind]=1.d0/sqrt(1.d0+yycos[*,ind]*yycos[*,ind])
          yyder=poly((x[j]-xoffset[ind])*xscale[ind],orders[1:*,ind]*(dindgen(pwr)+1))
          yyder=yyder*xscale[ind]
          ord_err[ind]=sqrt(total(((y[j]-poly((x[j]-xoffset[ind])*xscale[ind] $
                                       ,orders[*,ind]))/sqrt(1.+yyder*yyder))^2)/nj)
          if(keyword_set(iplot) and silent ne 1) then $
            oplot,xx[cl_limits[0,ind]:cl_limits[1,ind]] $
                 ,yy[cl_limits[0,ind]:cl_limits[1,ind],ind],col=0
          ind=ind+1
        endif
      endif else index[j]=0
    endif
  endfor

  nregions=ind+1
  orders   =orders[*,0:nregions-2]
  xoffset  =xoffset[0:nregions-2]
  xscale   =xscale[0:nregions-2]
  yy       =yy[*,0:nregions-2]
  cl_limits=cl_limits[*,0:nregions-2]
  ord_err  =ord_err[0:nregions-2]

;  if(nregions le 2) then begin
;    mean_sep=1
;  endif else begin   ; take the mean distance between orders but be restrictive
;    yo=dblarr(nregions-1)
;    for kkk=0,nregions-2 do yo[kkk]=poly((double(nx/2)-xoffset[kkk])*xscale[kkk] $
;                                        , orders[*,kkk])
;    kkk=where(orders[0,0:nregions-2] ge 0 and yo lt ny, nkkk)
;    if(nkkk gt 2) then begin
;      yo=minmax(middle(orders(0,sort(orders[0,kkk])),1,/poly))
;      mean_sep=(yo[1]-yo[0])/nkkk
;    endif else mean_sep=10
;;    mean_sep=(total(orders[0,1:nregions-2]- $
;;                    orders[0,0:nregions-3])/(nregions-2))<40
;;    ireg=0
;;    for i=0,nregions-2 do begin
;;      ind=where(index eq i+1, nind)
;;      if(nind gt 0) then begin
;;        yo[ireg]=max(abs(y[ind]-yy[x[ind]]))-min(abs(y[ind]-yy[x[ind]]))
;;        ireg=ireg+1
;;      endif
;;    endfor
;;    mean_sep=median(yo)
;  endelse
;  mean_sep=(mean_sep*0.5)>3
;;  print,mean_sep

; Cluster merging loop.
; We loop through all clusters and identify the overap
; The results are stored in array imerge where the imerge[0,*] contains the
; number of overlaping pixels while imerge[1,*] points to the overlapping
; cluster number. The limits for the overlap region are stored in imerge[2:3,*].
  imerge=intarr(4,nregions-1)
  for i=1,nregions-2 do begin
    j=intarr(nregions-1-i)
    lm=intarr(2,nregions-1-i)
    i_left =cl_limits[0,i-1]
    i_right=cl_limits[1,i-1]
    for ii=i+1,nregions-1 do begin
      ii_left =cl_limits[0,ii-1]
      ii_right=cl_limits[1,ii-1]
      iii1=where(yy[ i_left: i_right,ii-1] ge 0  and $
                 yy[ i_left: i_right,ii-1] lt ny and $
                 abs(yy[ i_left: i_right, i-1]-yy[ i_left: i_right,ii-1])* $
                    (yycos[ii_left:ii_right,ii-1]+yycos[ i_left: i_right, i-1])*0.5 lt 3*ord_err[ i-1], niii1)
      iii2=where(yy[ii_left:ii_right, i-1] ge 0  and $
                 yy[ii_left:ii_right, i-1] lt ny and $
                 abs(yy[ii_left:ii_right, i-1]-yy[ii_left:ii_right,ii-1])* $
                    (yycos[ii_left:ii_right,ii-1]+yycos[ i_left: i_right, i-1])*0.5 lt 3*ord_err[ii-1], niii2)

;      iii1=where(yy[ii_left:ii_right, i-1] ge yy_bot[ii_left:ii_right,ii-1] and $
;                 yy[ii_left:ii_right, i-1] le yy_top[ii_left:ii_right,ii-1], niii1)
;      iii2=where(yy[ i_left: i_right,ii-1] ge yy_bot[ i_left: i_right, i-1] and $
;                 yy[ i_left: i_right,ii-1] le yy_top[ i_left: i_right, i-1], niii2)

      niii=niii1+niii2
      if(niii1 gt 0 and niii2 gt 0) then begin
        iii=[iii1+i_left,iii2+ii_left]
      endif else if(niii1 gt 0) then begin
        iii=iii1+i_left
      endif else if(niii2 gt 0) then begin
        iii=iii2+ii_left
      endif else begin
        iii=[-2,-1]
      endelse
      j[ii-i-1]=niii;*(niii1/(niii1>1))*(niii2/(niii2>1))
      lm[*,ii-i-1]=[min(iii),max(iii)]
    endfor
    imerge[0,i-1]=max(j,niii)
    imerge[1,i-1]=niii+i
    imerge[2:3,i-1]=lm[*,niii]
    ii=where(skip[0,*] eq i and skip[1,*] eq niii+i, miii)
    if(miii gt 0) then imerge[0,i-1]=0
  endfor

skip_pair:
  lmerge=max(imerge[0,*],nmerge)  ; Largest overlap of lmerge pixels is between
                                  ; clusters nmerge and imerge(1,nmerge)
  if(lmerge ge 5) then begin
    jmerge=imerge[1,nmerge]       ; Cluster nmerge has largest overlap with jmerge
    if(keyword_set(iplot)) then begin
;=============================================
      x_plot_old=!x & y_plot_old=!y & pold=!p
      wset,1
      j=where(index eq jmerge+1)
      cluster_j_x=x[j]
      cluster_j_y=y[j]
      j=where(index eq nmerge+1)
      cluster_n_x=x[j]
      cluster_n_y=y[j]
      xr=minmax([cluster_j_x,cluster_n_x])
      xr=[(xr[0]-3)>0,(xr[1]+3)<(nx-1)]
      yr=minmax([cluster_j_y,cluster_n_y])
      yr=[(yr[0]-3)>0,(yr[1]+3)<(ny-1)]
      display,im,/log,xr=xr,yr=yr,tit='Clusters '+strtrim(jmerge,2)+ $
                                              '+'+strtrim(nmerge,2)
      if keyword_set(color) then begin
        device,/DECOMPOSED
        oplot,cluster_j_x,cluster_j_y,psym=1,col=255L*256L*256L
        oplot,cluster_n_x,cluster_n_y,psym=4,col=255L
        oplot,xx,yy[*,nmerge],col=(127L*256L+127L)*256L+127L
        oplot,xx,yy[*,jmerge],col=(127L*256L+127L)*256L+127L,line=2
      endif else begin
        oplot,cluster_j_x,cluster_j_y,psym=1,col=0
        oplot,cluster_n_x,cluster_n_y,psym=4,col=!d.n_colors-1
        oplot,xx,yy[*,nmerge],col=128
        oplot,xx,yy[*,jmerge],col=128,line=2
      endelse
;      s=get_kbrd(1)
      x_plot_new=!x & y_plot_new=!y & pnew=!p
      wset,0
      !x=x_plot_old & !y=y_plot_old & !p=pold
;=============================================
bad_answer:
;      oplot,xx,yy[*,nmerge] & oplot,xx,yy[*,jmerge],line=2
      if((imerge[3,nmerge]<cl_limits[1,nmerge]) $    ; If 90% overlap - merge
        -(imerge[2,nmerge]>cl_limits[0,nmerge]) gt $ ; without asking
          0.9*(cl_limits[1,nmerge]-cl_limits[0,nmerge]) or $
         (imerge[3,nmerge]<cl_limits[1,jmerge]) $
        -(imerge[2,nmerge]>cl_limits[0,jmerge]) gt $
          0.9*(cl_limits[1,jmerge]-cl_limits[0,jmerge]) and $
          not keyword_set(MANUAL)) then begin
          s='m'
          silent=1
      endif else begin
;print,ord_err[jmerge],ord_err[nmerge],imerge[0,jmerge],imerge[0,nmerge]
        silent=0
        oplot,xx,yy[*,nmerge] & oplot,xx,yy[*,jmerge],line=2
        print,'Clusters '+strtrim(nmerge,2)+'+'+strtrim(jmerge,2)+ $
              ' seem to belong to the same group. You can also select'+ $
              ' a different pair with (C)ursor.'
        s='m'
        print,'Shall they be (M)erged, (I)gnored or shall I discard (S)olid '+ $
              'line or (D)ashed line? '
        s=get_kbrd(1)
      endelse
      if(s eq 'm' or s eq 'M') then begin
        print,'Merging clusters '+strtrim(nmerge,2)+' and '+strtrim(jmerge,2) $
             +' of total '+strtrim(nregions,2)
        j=where(index eq nmerge+1)
        index[j]=jmerge+1
      endif else if(s eq 's' or s eq 'S') then begin
        print,'discard Solid'
        oplot,xx,yy[*,nmerge] & oplot,xx,yy[*,jmerge],col=0
        s='n'
        print,'I am about to discard the marked cluster. '+ $
              'Are you sure (Y/N)? [N]'
        s=get_kbrd(1)
        if(s ne 'y' and s ne 'Y') then goto,bad_answer
        j=where(index eq nmerge+1)
        index[j]=0
      endif else if(s eq 'D' or s eq 'd') then begin
        print,'discard Dashed'
        oplot,xx,yy[*,nmerge],col=0 & oplot,xx,yy[*,jmerge]
        print,'I am about to discard the marked cluster. '+ $
              'Are you sure (Y/N)? [N]'
        s=get_kbrd(1)
        if(s ne 'y' and s ne 'Y') then goto,bad_answer
        j=where(index eq jmerge+1)
        index[j]=0
      endif else if(s eq 'C' or s eq 'c') then begin
        oplot,xx,yy[*,nmerge],col=0 & oplot,xx,yy[*,jmerge]
        wset,1
        !x=x_plot_new & !y=y_plot_new & !p=pnew
        print,'Click mouse button on the first cluster you want to merge'
        cursor,xcur_n,ycur_n,/DOWN,/DATA
        yo=dblarr(nregions-1)
        for kkkn=0,nregions-2 do yo[kkkn]= $
          poly((double(xcur_n)-xoffset[kkkn])*xscale[kkkn], orders[*,kkkn])
        yo=min(abs(ycur_n-yo),kkkn)
        oplot,xx,yy[*,kkkn],col=0,line=0,thick=3
        print,'Click on the cluster with which you want to merge'
        cursor,xcur_j,ycur_j,/DOWN,/DATA
        yo=dblarr(nregions-1)
        for kkkj=0,nregions-2 do yo[kkkj]= $
          poly((double(xcur_j)-xoffset[kkkj])*xscale[kkkj], orders[*,kkkj])
        yo=min(abs(ycur_j-yo),kkkj)
        oplot,xx,yy[*,kkkj],col=0,line=1,thick=3
        print,nmerge,kkkn,jmerge,kkkj
        nmerge=kkkn
        jmerge=kkkj
        j=where(index eq nmerge+1)
        index[j]=jmerge+1
        wset,0
        !x=x_plot_old & !y=y_plot_old & !p=pold
      endif else if(s eq 'I' or s eq 'i') then begin
        print,'Ignore'
        oplot,xx,yy[*,nmerge],col=0
        oplot,xx,yy[*,jmerge],col=0
        imerge[0,nmerge]=0
        skip=[[skip],[nmerge,jmerge]]
        goto,skip_pair
      endif else goto,bad_answer
      goto,next
    endif else begin
      j=where(index eq nmerge+1)
      index[j]=jmerge+1
      goto,next
    endelse
  endif

;display,im,/LOG;,yr=[3000,3143]
;for iii=0,nregions-2 do begin
;  oplot,poly((dindgen(nx)-xoffset[iii])*xscale[iii],orders[*,iii]),col=0
;endfor
;stop

  for i=0,nregions-2 do begin  ; Discard orders that stick out in the middle
    jj=where(index eq i+1, njj)
    if(njj gt 0) then begin
      x1=cl_limits[0,i]
      x2=cl_limits[1,i]
      y1=min(yy[x1:x2,i],iy1) & iy1=iy1+x1
      y2=max(yy[x1:x2,i],iy2) & iy2=iy2+x1
      if(yy[x1,i] ge 0 and yy[x1,i] lt ny and $ ; left and right values are within
         yy[x2,i] ge 0 and yy[x2,i] lt ny and $ ; range but min or max are outside
         (y1 le 0 or  y2 ge ny)) then index[jj]=0
      if(y1 lt  0 and (yy[x1,i] ge ny or $        ; min<0 and one of the ends or 
                       yy[x2,i] ge ny or $        ; max are out of the roof
                      y2 ge ny)) then index[jj]=0
      if(y2 ge ny and (yy[x1,i] le 0 or $         ; max is outside the top boundary
                       yy[x2,i] le 0 or $         ; and one of the ends is below zero 
                      y1 le 0)) then index[jj]=0
    endif
  endfor

  yy=fltarr(nx,nregions-1)
  ord_err=dblarr(nregions-1)
  orders=dblarr(power+1,nregions-1)
  ind=0
  cl_limits=intarr(2,nregions-1)   ; starting and ending columns of clusters

  for ireg=1,nregions-1 do begin
    j=where(index eq ireg, nj)
    if(nj gt 0) then begin ; Check if cluster is not empty
      if(n_elements(uniq(x[j])) gt power) then begin ; Check if cluster includes
        index[j]=ind+1                               ; enough different pixels
        coef=poly_fit(x[j],y[j],power,/double)
                                                     ; Check if this cluster is
                                                     ; not a vertical artifact
        if(abs((poly_fit(x(j),y[j],1,/double))[1]) lt 4.*ny/nx) then begin
          cl_limits[*,ind]=minmax(x[j])
          orders[*,ind]=coef
          yy[*,ind]=poly(xx,orders[*,ind])
          ord_err[ind]=sqrt(total((y[j]-poly(x[j],orders[*,ind]))^2)/nj)
          ind=ind+1
        endif
      endif else index[j]=0
    endif
  endfor
  nregions=ind+1

; Kill curvy lines with derivatives way of the average
  if(nregions gt 5) then begin
    for i=power,1,-1 do begin
      n_sigmas=8
      repeat begin
        nregions=n_elements(orders[0,*])+1
        orders=orders[*,0:nregions-2]
        coef=reform(orders[i,*])
        mean_coef=poly(dindgen(nregions-1) $
                , poly_fit(dindgen(nregions-1), coef, 1, /DOUBLE))
        dev=stddev(coef-mean_coef)
        jgood=where(abs(coef-mean_coef) lt n_sigmas*dev, ngood, $
                                           ncomplement=nbad, complement=bad)
        if(keyword_set(MANUAL) and nbad gt 0) then begin
          wset,1
          plot,coef,psym=1,ys=3,xs=3,yr=minmax(mean_coef)+(n_sigmas+2)*[-dev,dev] $
              ,tit='Polynomial coefficient #'+strtrim(i,2)
          oplot,bad,coef[bad],psym=4,symsize=2,  col=c24(2)
          oplot,bad,coef[bad],psym=4,symsize=2.5,col=c24(2)
          oplot,mean_coef
          oplot,mean_coef+n_sigmas*dev,line=3
          oplot,mean_coef-n_sigmas*dev,line=3
          wset,0
          loadct,0,/SILENT
          display,im,/LOG
          for iii=0,ngood-1 do oplot,poly(dindgen(nx),orders[*,jgood[iii]]),col=c24(0)
          for iii=0,nbad-1 do oplot,poly(dindgen(nx),orders[*,bad[iii]]),col=c24(2),thick=3
          print,'I believe that traces shown in red are not following spectral orders '
          print,'and they should be discarded. Do you agree (Y/N)? [N] '
          s=get_kbrd(1)
          if s ne 'Y' and s ne 'y' then begin
            ngood=nregions-1
            jgood=indgen(ngood)
            nbad=0
            n_sigmas=ceil(max(abs(coef-mean_coef))/dev)
          endif
        endif
        if(ngood gt 0) then begin
          orders=orders[*,jgood]
          cl_limits=cl_limits[*,jgood]
          ord_err=ord_err[jgood]
          yy=yy[*,jgood]
          xoffset=xoffset[jgood]
          xscale =xscale[jgood]
        endif else begin
          print,'This is terribly wrong'
          stop
        endelse
        if(nbad gt 0) then begin
          for ibad=0,nbad-1 do index[where(index eq bad[ibad]+1)]=0
        endif
      endrep until (ngood eq nregions-1)
    endfor
    nregions=n_elements(orders[0,*])+1
  endif

  if(keyword_set(iplot)) then wdelete,1

; Sorting of the orders: very tricky for highly-tilted or partial orders
;
; First, find all orders that based on a cluster crossing the middle column
; and store their Y coordinates for that column
  xmid=nx*0.5d0
  jcen=where(cl_limits[0,*] lt xmid and cl_limits[1,*] gt xmid, njcen)
  if njcen le 1 then stop
  ycen=dblarr(njcen)
  for jj=0,njcen-1 do ycen[jj]=poly(xmid,orders[*,jcen[jj]])
  jj=sort(ycen)
  jcen=jcen[jj]
  ycen=ycen[jj]

; Second, go through each order and find other orders with cluster overlap in columns
  for i=0,nregions-2 do begin
    xmid=(cl_limits[0,i]+cl_limits[1,i])*0.5
    j=where(cl_limits[0,*] lt xmid and cl_limits[1,*] gt xmid, nj)
    if nj le 1 then continue
    igood = i eq 0?i:[igood, i]
    ymid=dblarr(nj)
    for jj=0,nj-1 do ymid[jj]=poly(xmid,orders[*,j[jj]])
    jj=sort(ymid)
    j=j[jj]
    ymid=ymid[jj]

; Now we have to cross-match j and jcen and determine the shift in Y to bring
; ymiddle to the reference of ycen
    ii=intarr(nj)-1
    kk=intarr(nj)-1
    for jj=0,nj-1 do begin
      iwh=where(j[jj] eq jcen, nwh)
      if(nwh gt 0) then begin
        ii[jj]=jj
        kk[jj]=iwh[0]
      endif
    endfor
    iwh=where(ii ge 0, nwh)
    if(nwh eq 0) then stop
    ii=ii[iwh]
    jwh=where(kk ge 0, nwh)
    if(nwh eq 0) then stop
    kk=kk[iwh]
; Shift zero point to match the middle column
    ymid=ymid-mean(ymid[ii])+mean(ycen[kk])
; We might as well set the overlaping values precisely
    ymid[ii]=ycen[kk]
    if i eq 0 then begin
      ymiddle=ymid
      jmiddle=j
    endif else begin
      ymiddle=[ymiddle, ymid]
      jmiddle=[jmiddle,    j]
    endelse
  endfor

  yy=yy[*,igood]
  orders=orders[*,igood]
  cl_limits=cl_limits[*,igood]
  ord_err=ord_err[igood]
  nregions=n_elements(igood)+1

  i=sort(ymiddle)
  ymiddle=ymiddle[i]
  jmiddle=jmiddle[i]
  i=uniq(jmiddle)
  i=jmiddle[i]
  yy=yy[*,i]
  orders=orders[*,i]
  cl_limits=cl_limits[*,i]
  ord_err=ord_err[i]

  if(keyword_set(iplot)) then begin
    loadct,0,/SILENT
    display,im,/log,min=(median(im)+3.*min(im))/4.
    for i=0,nregions-2 do begin
      x1=cl_limits[0,i]
      x2=cl_limits[1,i]
      oplot,xx[x1:x2],yy[x1:x2,i],col=0
;      sss=get_kbrd(1)
    endfor
;    stop
  endif
  return
end
