pro modeinfo_salt_hrs,mode,newhead,object,orient,xlo,xhi,ylo,yhi,gain,readn,backg,time $
                     ,obslat,obslon,obsalt,ra2000,de2000,jd,NONLINEAR=nonlinear
;===========================================================================================
;The SALT HRS spectrometer (2-amplifier mode)

  if mode eq 'salt_hrs_blue' then begin
    reorient = 0 ; Wavelength runs left to right with red orders at the top
  endif else if mode eq 'salt_hrs_red' then begin
    reorient = 7 ; Wavelength runs left to right with red orders at the bottom
  endif 

  if n_elements(orient) eq 0 then orient = reorient

  xlo=26
  xhi=hierarch(newhead, 'NAXIS1')-1
  ylo=0
  yhi=hierarch(newhead, 'NAXIS2')-1

  if keyword_set(xr) then begin
    xlo = xr(0)
    xhi = xr(1)
  endif
  if keyword_set(yr) then begin
    ylo = yr(0)
    yhi = yr(1)
  endif

  if n_elements(gain) eq 0 then begin
    gain = 1.
  endif

  if n_elements(readn) eq 0 then begin
    readn = hierarch(newhead, 'RDNOISE')
  endif

  if n_elements(backg) eq 0 then begin
    drk = 0.
    sky = 0.
    backg = gain * (drk + sky)        ;convert ADU to electrons
  endif

  if n_elements(time) eq 0 then begin
    time = hierarch(newhead, 'EXPTIME', count=count, errmes=errmes)
    if count eq 0 then message, errmes
  endif

; For object frames, prepare for heliocentric correction
  imtype=hierarch(newhead,'OBJECT',count=count,errmes=errmes)
  imtype=strtrim(imtype, 2)

  if(imtype ne 'Arc' and imtype ne 'Flat field' and imtype ne 'Bias') then begin
    if n_elements(ra2000) eq 0 then begin
      ra = hierarch(newhead,'RA',count=count, errmes=errmes)
      ra = float(strsplit(ra,':',/EXTRACT))
      ra = ten(ra[0],ra[1],ra[2])
      ra2000 = ra/3600.
    endif
    if n_elements(de2000) eq 0 then begin
      dec = hierarch(newhead,'DEC',count=count, errmes=errmes)
      dec = float(strsplit(dec,':',/EXTRACT))
      dec = ten(dec[0],dec[1],dec[2])
      de2000 = dec/3600.
    endif
    if n_elements(jd) eq 0 then begin
      date_obs = hierarch(newhead, 'DATE-OBS', count=count, errmes=errmes)
      ut = hierarch(newhead, 'TIME-OBS', count=count, errmes=errmes)
      date_obs = strsplit(date_obs, '-', /EXTRACT)
      ut = float(strsplit(ut, ':', /EXTRACT))
      ut = ut[0] + ut[1] / 60.d0 + ut[2] / 3600.d0
      jdcnv,date_obs[0], date_obs[1], date_obs[2], ut, jd  ;convert UT to JD
      jd = jd - 2400000.d0 + time * 0.5d0
    endif
;observatory coordinates
    if n_elements(obslon) eq 0 then obslon =-hierarch(newhead, 'SITELONG'); East is negative
    if n_elements(obslat) eq 0 then obslat = hierarch(newhead, 'SITELAT')
    if n_elements(obsalt) eq 0 then obsalt = hierarch(newhead, 'SITEELEV')
  endif

  return
end
