function sarmiento_redman_une,wrange=wrange,path=path,UNe=UNe,maxline=maxline $
                   ,ANGSTROEM=angstroem
  common une_atlas,file

  if keyword_set(angstroem) then wr=wrange*0.1 $ ; Convert input Angstoems to nanometers
  else                           wr=wrange

  if(keyword_set(path)) then file=path $
  else begin                 file='~/IDL/REDUCE/WAVECAL'
    help,calls=a
    a=strmid(a(0),strpos(a(0),'<')+1,strlen(a(0))-strpos(a(0),'<')-1)
    if(strpos(a,'/nfs') eq 0) then a=strmid(a,4)
    if(strpos(a,'/export') eq 0) then a=strmid(a,7)
    if(!VERSION.OS eq 'Win32') then delimiter='\' else delimiter='/'
    prefix=strmid(a,0,strpos(a,delimiter,/REVERSE_SEARCH)); kpno_thar directory
    if(strpos(a,delimiter) lt 0) then cd,CURRENT=prefix

    file=prefix+delimiter+'sarmiento_redman_UNe.fits'
  endelse

  fits_read,file,une,h,EXTEN=1         ; Read UNe line list
  
  w_une=reform(une[*,0])
  s_une=reform(une[*,1])
  une=0

  if(keyword_set(wr)) then begin   ;Select wavelength range if specified
    i=where(w_une gt wr[0] and w_une lt wr[1], nlines)
    if(nlines gt 0) then begin
      w_une=w_une[i]
      s_une=s_une[i]
    endif else return,-1
  endif

  fits_read,file,une,h,EXTEN=2         ; Read UNe spectrum
  
  wl=reform(une[*,0])
  sp=reform(une[*,1])

  if(keyword_set(wr)) then begin ;Select wavelength range if specified
    i=where(une[*,0] ge wr[0] and une[*,0] le wr[1], nlines)
    if(nlines gt 0) then begin
      une=une[i,*]
    endif else return,-2
  endif

  if(keyword_set(maxline)) then begin
    n=n_elements(w_une)
    if(n gt (maxline>5)) then begin
      i=(reverse(sort(s_une)))[0:maxline-1]
      w_une=w_une[i]
      s_une=s_une[i]
    endif
  endif

  if keyword_set(angstroem) then return,[[w_une*10.d0],[s_une]] $
  else                           return,[[w_une],      [s_une]]
end
